Codeforces 54C First Digit Law 数位dp+概率dp

题目链接:点击打开链接

题意:

给定n个区间

下面n个区间

从每个区间中任选一个数。则一共选出了n个数

给出K(<=100)

问选出的n个数中 最高位是1的个数 占n个数的百分之K以上的概率是多少。

先求出对于第i个区间 ,选出的数最高位是1的概率P[i]

dp[i][j] 表示前i个数选了j个最高位是1的概率.

//////////////////////////////////////
//**********************************//
//* ======= lalalalalala ========= *//
//* ------------------------------ *//
//**********************************//
//////////////////////////////////////
									///
#include        <map>              ///
#include       <set>             ///
#include      <list>           ///
#include     <cmath>          ///
#include      <queue>          ///
#include       <deque>           ///
#include        <vector>           ///
#include        <string>           ///
#include       <cstdio>          ///
#include      <cstdlib>        ///
#include       <cstdarg>       ///
#include        <string.h>       ///
#include         <iostream>        ///
#include         <algorithm>        ///
//////////////////////////////////////
typedef long long ll;
template <class T>
inline bool rd(T &ret) {
	char c; int sgn;
	if (c = getchar(), c == EOF) return 0;
	while (c != '-' && (c<'0' || c>'9')) c = getchar();
	sgn = (c == '-') ? -1 : 1;
	ret = (c == '-') ? 0 : (c - '0');
	while (c = getchar(), c >= '0'&&c <= '9') ret = ret * 10 + (c - '0');
	ret *= sgn;
	return 1;
}
template <class T>
inline void pt(T x) {
	if (x <0) {
		putchar('-');
		x = -x;
	}
	if (x>9) pt(x / 10);
	putchar(x % 10 + '0');
}
using namespace std;
ll solve(ll x){
	ll ans = 0, len = 0, high = 0, tmp = x, ten = 1;
	while (tmp){
		len++;
		high = tmp % 10;
		tmp /= 10;
	}
	for (int i = 1; i < len; i++, ten *= 10)
		ans += ten;
	if (high > 1)return ans + ten;
	else if (high == 1)return ans + x - ten + 1;
	return ans;
}
const int N = 1005;
int n;
double p[N], K;
double dp[N][N]; //dp[i][j]表示前i个选了j个1的概率
int main(){
	while (cin >> n){
		for (int i = 1; i <= n; i++){
			ll l, r; rd(l); rd(r);
			p[i] = (double)(solve(r) - solve(l-1)) / (r - l + 1);
		}
		rd(K);
		memset(dp, 0, sizeof dp);
		dp[0][0] = 1;
		for (int i = 0; i < n; i++){
			for (int j = 0; j <= i; j++)
			{
				dp[i + 1][j] += dp[i][j] * (1 - p[i + 1]);
				dp[i + 1][j + 1] += dp[i][j] * p[i + 1];
			}
		}

		double ans = 0;
		for (int i = 0; i <= n; i++)
		if (double(i) >= K*n/100.0)
			ans += dp[n][i];
		printf("%.10f\n", ans);
	}
	return 0;
}
时间: 2024-10-07 18:55:03

Codeforces 54C First Digit Law 数位dp+概率dp的相关文章

Codeforces 148D 一袋老鼠 Bag of mice | 概率DP 水题

除非特别忙,我接下来会尽可能翻译我做的每道CF题的题面! Codeforces 148D 一袋老鼠 Bag of mice | 概率DP 水题 题面 胡小兔和司公子都认为对方是垃圾. 为了决出谁才是垃圾,大哥拿来了一袋老鼠,其中有w只白老鼠和b只黑老鼠.胡小兔先抓,先抓到白老鼠的人赢. 每次学姐抓完老鼠之后,总会有另外一只老鼠从袋子里自己跑出来(这只老鼠不算任何人抓的),而胡小兔抓老鼠时则不会发生这样的事. 每次袋子里的每只老鼠被抓到的概率相等,当有一只老鼠跑出来的时候,每只老鼠跑出来的几率也相

CodeForces 54C-First Digit Law(数位,概率dp)

题意: 给你n个区间,在每个区间里各取一个数(随机取),求这n个数中超过K%的数是首位为1数的概率 分析: dp[i][j]取前i个数,有j个是首位为1的数的概率 易知,dp[i][j]=dp[i-1][j]*(1-p[i])+dp[i-1][j-1]*p[i]; 现在关键是求p[i],第i个区间首位为1的数出现的概率,用数位统计一下即可 #include <map> #include <set> #include <list> #include <cmath&g

bzoj1076 奖励关 状压dp 概率dp

链接:http://www.lydsy.com/JudgeOnline/problem.php?id=1076 题意:给出n种物品,每种物品有牵制条件和价值,有k次选择机会,每次每个物品等概率出现,问平均情况下最大收益.(n<=15) 首先看到这个n的范围和限制条件就应该想到是状压. 定义数组f[i][j]为当前处在第i次抛物品时间,状态为j. 但是如果我们仅仅这样定义并正向转移就会遇到一个问题:我们是有可能从无效状态推出有效状态,进而得出错误的结论的.例如,1的限制条件为2.3.4,那么我们就

Codeforces Div.301D Bad Luck Island(概率dp+记忆化搜索)

一道概率dp问题. 题目链接:http://codeforces.com/contest/540/problem/D 题目大意:一个岛上有r个石头,s个剪子,p个布,他们之间随机挑出两个相遇,如果不是相同物种,就会有一个消失,分别求出最后这座岛上只剩下一个物种的概率. 我们用dp[i][j][k]来存储i个石头,j个剪刀,k个布时,某物种的存活概率,共dp三次,算出三个物种分别的概率. 首先,我们需要把对应想求的物种概率初始化,这里以石头为例,那么对于i从1到r,不难理解dp[i][0][0]=

CodeForces 540D Bad Luck Island 概率dp

CodeForces 540D 应该是简单概率dp,由于写得少显得十分蠢萌 求期望逆推,求概率正推,大概是这么个意思,贴一发留恋 #include<cstdio> #include<cstring> #include<algorithm> using namespace std; #define db double const int maxn=108; db dp[maxn][maxn][maxn]; int main() { int i,j,n,m,k,p; whi

Codeforces 148D Bag of mice (概率dp)

D. Bag of mice time limit per test:2 seconds memory limit per test:256 megabytes The dragon and the princess are arguing about what to do on the New Year's Eve. The dragon suggests flying to the mountains to watch fairies dancing in the moonlight, wh

Codeforces Round #362 (Div. 1) B. Puzzles 树形dp,概率

题目链接: http://codeforces.com/problemset/problem/696/B 题意: 一个树,dfs遍历子树的顺序是随机的.所对应的子树的dfs序也会不同.输出每个节点的dfs序的期望 思路: http://www.cnblogs.com/01world/p/5795498.html 假设四个子节点为A,B,C,D,因为排列等可能,所以A在B前面的概率跟A在B后面的概率相等,C和D对于A而言一样.所以遍历A的时间期望就是( t(B) + t(C) + t(D) )/2

Codeforces 518D Ilya and Escalator (概率dp)

Ilya and Escalator time limit per test: 2 seconds memory limit per test: 256 megabytes Ilya got tired of sports programming, left university and got a job in the subway. He was given the task to determine the escalator load factor. Let's assume that

codeforces 235B Let&#39;s Play Osu! 概率dp

题意:给定n表示有n个格子,下面每个格子为O的概率是多少.对于一段连续 x 个O的价值就是 x^2 ;求获得的价值的期望是多少. 思路:n^2=n×(n-1)+n,设ai为第i段连续O的长度,∑ai^2 = ∑[ ai+ ai*(ai-1) ] = ∑ ai*(ai-1) + ∑ai = ∑ C(ai, 2)*2 + ∑ai,那么问题可以转 化为求长度大于1的连续段数*2+O的个数的总期望. ∑ai我们可以理解为O的总个数,所以它的期望为∑pi: C(ai, 2)*2我们可以认 为是连续ai个O